package com.gic.haoban.manage.api.service;

import java.util.List;
import java.util.Set;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.StaffClerkBindLogDetailDTO;
import com.gic.haoban.manage.api.dto.StaffClerkInfoDTO;
import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;

public interface StaffClerkRelationApiService {
	/**
	 * 绑定日志
	 * @param params
	 */
	public void  bindLogMq(String params);

	List<StaffClerkRelationDTO> listBindCode(String enterpriseId, Set<String> clerkCodeList);

	List<StaffClerkRelationDTO> listBindCodeByStaffId(List<String> enterpriseIdList, String staffId);

	/**
	 * 根据staffid 获取列表
	 * @param staffId
	 * @return
	 */
	List<StaffClerkInfoDTO> listBindDetailByStaffId(String staffId);

	/**
	 * 绑定
	 * @return
	 */
	public ServiceResponse bindStaffClerk(StaffClerkRelationDTO staffClerkRelationDTO,String optStaffId,int chanelCode);
	
	StaffClerkRelationDTO getByCodeAndEnterpriseId(String clerkCode, String enterpriseId);

	

	
	void delAndInsert(StaffClerkRelationDTO staffClerkRelation,String optStaffId,int chanelCode);
	/**
	 * 解绑
	 * @param storeId
	 * @param clerkCode
	 * @return
	 */
	String delByStoreIdAndCode(String storeId,String clerkCode);


	StaffClerkRelationDTO getOneByClerkId(String clerkId);
	
	List<StaffClerkRelationDTO> listByClerkIds(List<String> clerkIds);

	/**
	 * 导购列表
	 * @param storeId
	 * @return
	 */
	List<StaffClerkRelationDTO>listByStoreId(String storeId);

	/**
	 * 解绑
	 * @param staffId 操作人
	 * @param clerkId
	 * @return
	 */
	boolean unbindByStaffAndClerkId(String staffId,String clerkId);
	
	/**
	 * 查询导购信息
	 * @param clerkId
	 * @return
	 */
	StaffClerkRelationDTO getOneByStoreIdAndStaffId(String storeId,String staffId);
	
	/**
	 * 查询导购信息
	 * @param clerkId
	 * @return
	 */
	StaffClerkRelationDTO getByClerkId(String clerkId);
	/**
	 * 
	 * @param enterpriseId
	 * @param wxUserId
	 * @return
	 */
	List<StaffClerkRelationDTO> listByEnterpriseIdAndWxUserId(String enterpriseId,String wxUserId);
	/**
	 * 删除关联关系
	 * @param clerkId
	 */
	void delByClerkId(String clerkId);

	/**
	 * 搜索查询列表
	 * @param wxEnterpriseId
	 * @param search
	 * @param enterpriseId
	 * @param optType
	 * @return
	 */
	public Page<StaffClerkBindLogDetailDTO> pageStaffClerkBindLog(String wxEnterpriseId, String search, String enterpriseId, int optType, BasePageInfo pageInfo);

	/**
	 * 追加到绑定日志
	 * @param staffId
	 * @param optStaffId
	 * @param optType
	 * @param channelCode
	 * @param relationId
	 */
	public void pushToBindLog(String staffId,String optStaffId,int optType,int channelCode,String relationId);


	/**
	 * 获取config
	 * @param clerkId
	 * @param memberId
	 * @return
	 */
	ServiceResponse<String> getClerkMemberChatConfig(String clerkId);
}
