package com.gic.haoban.manage.service.task;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.haoban.manage.api.dto.DealParamMqDTO;
import com.gic.haoban.manage.api.dto.ExternalUserDTO;
import com.gic.haoban.manage.api.enums.PreDealStatusEnum;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.service.entity.TabHaobanPreDealLog;
import com.gic.haoban.manage.service.service.PreDealService;

@Service
public class FriendMergeSyncOperation implements BaseSyncOperation{
	private static final Logger logger = LoggerFactory.getLogger(FriendMergeSyncOperation.class);
	@Autowired
	private MemberUnionidRelatedApiService memberUnionidRelatedApiService;
	@Autowired
	private PreDealService preDealService;
	@Override
	public void dealSingleByMq(DealParamMqDTO dealParamMqDTO, TabHaobanPreDealLog dataPre) {
		String reason = "";
		boolean dealFlag = true;
		try {
			String dataContent = dataPre.getDataContent();
			ExternalUserDTO pojo = JSON.parseObject(dataContent, ExternalUserDTO.class);
			String res = memberUnionidRelatedApiService.addExternal(pojo);
			if(StringUtils.isBlank(res)){
				dealSuccess(dealParamMqDTO.getTaskId(), dataPre.getDataId(), null, null);
			}
		} catch (Exception e) {
			e.printStackTrace();
			logger.info("同步失败：{},{}", JSONObject.toJSONString(dataPre),e);
            reason = "合并处理异常";
            dealFlag = false;
		}finally {
			if (!dealFlag) {
               dealException(dealParamMqDTO.getTaskId(), dealParamMqDTO.getData(), dataPre.getEnterpriseId(), reason);
           } 
		}
		
	}

	@Override
	public void dealException(String taskId, String dataId, String enterpriseId, String reason) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.exception.getVal(), reason);
		
	}

	@Override
	public void dealSuccess(String taskId, String dataId, String enterpriseId, String wxEnterpriseId) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.computed.getVal(), "成功");
		
	}

	@Override
	public void checkDepartmentTask(String taskId) {
		
	}

}
